#include "datastructures.h"

int matrix_show(CvMat* m)
{
	for(int i=0; i<m->rows; i++)
	{
		printf("%i:[",i);
		{
		for(int j=0; j<m->cols; j++)
			printf(" % .3g", ((float*) (m->data.ptr + m->step*i))[j]);
		}
		printf(" ]\n");
	}

	return 0;
}

classpdfArray* createclasspdfArray(int Nc, int fv_dim)
{
	classpdfArray* cpdf = (classpdfArray*) malloc(sizeof(classpdfArray));

	cpdf->Nc = Nc;
	cpdf->cpdfptr = (classpdf*) malloc(Nc*sizeof(classpdf));

	for(int i=0; i<cpdf->Nc; i++)
	{
		cpdf->cpdfptr[i].cov_det = 1.0;
		cpdf->cpdfptr[i].prior = 0.0;
		cpdf->cpdfptr[i].mu = cvCreateMat( 1, fv_dim,  CV_32FC1 );
		cvSetZero(cpdf->cpdfptr[i].mu);
		cpdf->cpdfptr[i].cov_inv = cvCreateMat( fv_dim, fv_dim, CV_32FC1 );		
		cvSetIdentity(cpdf->cpdfptr[i].cov_inv);
	}

	return cpdf;
}

void releaseclasspdfArray(classpdfArray* cpdf)
{
	for(int i=0; i<cpdf->Nc; i++)
	{
		cvReleaseMat( &(cpdf->cpdfptr[i].mu) );
		cvReleaseMat( &(cpdf->cpdfptr[i].cov_inv) );
	}

	free(cpdf->cpdfptr);
	free(cpdf);
}

void releasembank(mbank* mb)
{
	for(int i=0; i < mb->size; i++)
	{
		cvReleaseMat( &(mb->mask[i]) );
	}
	free( mb );
}