// ---------------------------------------------------------------------
// File: gui.h
// Author: Miguel Torres-Torriti (c) 2008.11.21-2009.02.06 v. 1.0
// Change log:
//	2008.11.22, v.1.0, MTT: First (single-file) version was created
//                          using global variables.
//  2009.02.06, v.2.0, MTT: GUI functions were made to that
//                          the input is passed as a pointer
//                          through the optional parameters of 
//                          the callbacks.
// Description:
//  This file provides basic GUI functionality with pixel
//  and area selection over the input image or video.
//  Modify the routines in this file according to your own needs.
// Remarks:
//  Define your own window names and callbacks according to 
//  the needs of your application.
//
// ---------------------------------------------------------------------
#ifndef GUI_H
#define GUI_H

#include "cv.h"       // use " " instead of < > to get list of class/struct members
#include "highgui.h"  // use " " instead of < > to get list of class/struct members
#include "datastructures.h"

extern char wndname[],
	 wndname2[],
	 wndname3[];

extern char tbarname2[];
extern char tbarname3[];
extern int cr_thresh;
extern int edge_thresh;

extern CvPoint mpos;		// Current mouse position
extern CvPoint mpos_prev;	// Previous mouse position

extern CvScalar color_table[20];

double bboxarea(bbox rect);
void on_mouse( int event, int x, int y, int flags, void* param );
void on_trackbar2(int h);
void on_trackbar3(int h);

#endif